Subject: [core] Fwd: statement regarding keepalives

From: Carsten Bormann <[email-masked]>
Date: Fri, 13 Jul 2018 07:09:20 +0200

There is a discussion  going on in tsvarea on keepalives.
It seems to me that  the facilities in RFC 8323 are already in line with the thinking at least of the initial draft statement (and so is RFC 7252’s original “CoAP ping”).
Those who care about keepalives, ping/pong etc. may want to follow this discussion…

Grüße, Carsten

> Begin forwarded message:
> 
> From: Kent Watsen <[email-masked] <mailto:[email-masked]>>
> Subject: statement regarding keepalives
> Date: July 13, 2018 at 02:37:59 GMT+2
> To: "[email-masked] <mailto:[email-masked]>" <[email-masked] <mailto:[email-masked]>>
> Cc: "[email-masked] <mailto:[email-masked]>" <[email-masked] <mailto:[email-masked]>>, "[email-masked] <mailto:[email-masked]>" <[email-masked] <mailto:[email-masked]>>, "[email-masked] <mailto:[email-masked]>" <[email-masked] <mailto:[email-masked]>>
> Archived-At: <https://mailarchive.ietf.org/arch/msg/tsv-area/fmz3WMUmZUiRUMm2AJgsA85QY94 <https://mailarchive.ietf.org/arch/msg/tsv-area/fmz3WMUmZUiRUMm2AJgsA85QY94>>
> 
> 
> Dear TSVAREA,
> 
> The folks working with the BBF asked the NETMOD WG to consider modifying draft-ietf-netconf-netconf-client-server to support TCP keepalives [1].  However, it is unclear what IETF's position is on the use of keepalives, especially with regards to keepalives provided in protocol stacks (e.g., <some-app> over HTTP over TLS over TCP).
> 
> After some discussion with Transport ADs (Spencer and Mijra) and the TLS ADs (Eric and Ben), the following draft statement has been crafted.  Spencer and Mijra have requested TSVAREA critique it before, perhaps, developing a consensus document around it in TSVWG.
> 
> It would be greatly appreciated if folks here could review and provide comments on the draft statement below.  The scope of the statement can be increased or reduced as deemed appropriate. 
> 
> [1] https://mailarchive.ietf.org/arch/msg/netconf/MOzcZKp2rSxPVMTGdmmrVInwx2M <https://mailarchive.ietf.org/arch/msg/netconf/MOzcZKp2rSxPVMTGdmmrVInwx2M> 
> 
> Thanks,
> Kent (and Mahesh) // NETCONF chairs
> 
> 
> ===== STATEMENT =====
> 
> When the initiator of a networking session needs to maintain a persistent connection [1], it is necessary for it to periodically test the aliveness of the remote peer.  In such cases, it is RECOMMENDED that the aliveness check happens at the highest protocol layer possible that is most meaningful to the application, to maximize the depth of the aliveness check.  
> 
> E.g., for an HTTPS connection to a simple webserver, HTTP-level keepalives would test more aliveness than TLS-level keepalives.  However, for a webserver that is accessed via a load-balancer that terminates TLS connections, TLS-level aliveness checks may be the most meaningful check that could be performed.
> 
> In order to ensure aliveness checks can always occur at the highest protocol layer, it is RECOMMENDED that protocol designers always include an aliveness check mechanism in the protocol and, for client/server protocols, that the aliveness check can be initiated from either peer, as sometimes the "server" is the initiator of the underlying networking connection (e.g., RFC 8071).
> 
> Some protocol stacks have a secure transport protocol layer (e.g., TLS, SSH, DTLS) that sits on top of a cleartext protocol layer (e.g., TCP, UDP).  In such cases, it is RECOMMENDED that the aliveness check occurs within protection envelope afforded by the secure transport protocol layer.  In such cases, the aliveness checks SHOULD NOT occur via the cleartext protocol layer, as an adversary can block aliveness check messages in either direction and send fake aliveness check messages in either direction.
> 
> [1] While reasons may vary for why the initiator of a networking session feels compelled to maintain a persistent connection.  If the session is primarily quiet, and the use case can cope with the additional latency of starting a new connection, it is RECOMMENDED to use short-lived connections, instead of maintaining a long-lived persistent connection using aliveness checks.
> 
> 
> 
>